N=length(student_type);

%% Modify lott to set NaN to zero
for ii=1:length(lott)
   lott(ii).choice(isnan(lott(ii).choice)) = 0;
end
%% New type
d = load('data');
[type_desc,~,new_type]=unique([d.year d.ineg.data],'rows');
%% Loop over new types
for yy = unique(new_type)'
	fprintf('Type # %d, Year %d Ineligible list: ',yy,full(type_desc(yy,1)))
	fprintf('%d ',full(find(type_desc(yy,2:end)))); fprintf('\n');
	clearvars p 
    % Find the students in the type and stack their lotteries
    stu_type = student_type(new_type==yy);
    if numel(stu_type)>0
        new_lott(yy).choice = lott(stu_type(1)).choice;
        new_lott(yy).p = zeros(size(lott(stu_type(1)).p));
        for q = 1:numel(stu_type)
            new_lott(yy).p = new_lott(yy).p + 1/numel(stu_type) * lott(stu_type(q)).p;
        end
    end        
    assert(size(new_lott(yy).choice,1)==size(new_lott(yy).p,1)) % Uncomment for verification
end
% Write new lott and student_type and clear other variables related to the original lotteries
lott = new_lott;
student_type = new_type;
clearvars V constraint_matrix rationalized_students tag
% for tt=1:numel(lott), check_monotonicity; end  % Uncomment for verification
