N=length(paidlunch);
J=size(rank.data,2);

%% Re-assignment 
% Define a grouping of students; 
coarse_type = paidlunch + 1;
% Iterate on each grouping;
where_rank1 = mod(find(rank.data==1),J);
rk=rank.data; rk(rk==0)=4;
rank_asgn = sum(asgn.data.*rk,2); rank_asgn(rank_asgn==0)=5;
rank_regs = sum(regs.data.*rk,2); rank_regs(rank_regs==0)=5;
prob_bump1 = zeros(max(coarse_type),J+1);
prob_bump2 = zeros(max(coarse_type),J+1);
prob_bump3 = zeros(max(coarse_type),J+1);
prob_upgr = zeros(max(coarse_type),J+1);
for t = 1:size(prob_bump1,1)
	for j = 1:J
		k= coarse_type==t;
		prob_bump1(t,j) = sum(rank_regs(k)==1 & rank_asgn(k)~=1 & rank.data(k,j)==1)/sum(rank_asgn(k)~=1 & rank.data(k,j)==1);
							% reg at 1st rk        ranked j 1st          not assigned to 1st  ranked j 1st
		prob_bump2(t,j) = sum(rank_regs(k)==2 & rank_asgn(k)>2 & rank.data(k,j)==2)/sum(rank_asgn(k)>2 & rank.data(k,j)==2 & rank_regs(k)>1);
							% reg at 2nd rk        ranked j 1st          not assigned to 2nd  ranked j 2ND
		prob_bump3(t,j) = sum(rank_regs(k)==3 & rank_asgn(k)>3 & rank.data(k,j)==3)/sum(rank_asgn(k)>3 & rank.data(k,j)==3 & rank_regs(k)>2);
		prob_upgr(t,j) = sum(rk(k,j)<4 & rank_regs(k)<rank_asgn(k) & regs.data(k,j) == 1 )/sum(rk(k,j)<4 & rank_asgn(k)>rk(k,j) & rank_regs(k)>=rank.data(k,j));
							% ranked j    upgraded                    reg at j              ranked j		rejected at j            not registered strictly better than j
	end
end
prob_upgr(isnan(prob_upgr))=0.1;
prob_bump1(isnan(prob_bump1))=0.1;
prob_bump2(isnan(prob_bump2))=0.01;
prob_bump3(isnan(prob_bump3))=0.01;
prob_bump3=max(prob_bump3,0.01);
prob_bump2=max(prob_bump3,prob_bump2);
prob_bump1=max(prob_bump1,prob_bump2);


for st = 1:max(student_type)
	this_p = [lott(st).p zeros(size(lott(st).p,1),1)];
	for ch =1:size(lott(st).choice,1)
		this_choice = lott(st).choice(ch,:);
		j = this_choice(1); this_choice(isnan(this_choice))=J+1;
		t = mean(coarse_type(student_type==st));
		% Do conditional upgrades;
		pA = this_p(ch,this_choice(1)); pB = this_p(ch,this_choice(2)); pC = this_p(ch,this_choice(3));
		%mA = prob_upgr(t,this_choice(1)); mB = prob_upgr(t,this_choice(2)); mC = prob_upgr(t,this_choice(3));
		mA = prob_bump1(t,this_choice(1)); mB = prob_bump2(t,this_choice(2)); mC = prob_bump3(t,this_choice(3));
		this_p(ch,this_choice(1)) = pA + mA -pA*mA;
		this_p(ch,this_choice(2)) = (1 - mA)*(pB*(1-mB)+mB*(1-pA));
		this_p(ch,this_choice(3)) = (1 - mA)*(1-mB)*(pC*(1-mC)+mC*(1-pA-pB));
		assert(this_p(ch,this_choice(1))+this_p(ch,this_choice(2))+this_p(ch,this_choice(3))+(1 - mA)*(1-mB)*(1-mC)*(1-pA-pB-pC)-1<1e-7);
	end
	lott(st).p = this_p(:,1:J);
end


