function [out]=bootstrap_se(bs,this_field,student_list,fn)
% Average fn(pref_da_camb) across students for each bootstrap sample

assert(islogical(student_list));
bs_draws = size(bs.smpl,2);
out = zeros(bs_draws,1);
if nargin<4, fn = @(x) x; end
for b=1:bs_draws
    out(b)=mean(fn(bs.(this_field)(ismember(bs.smpl(:,b),find(student_list)),b)));
end
