function printRejectedTable(fid,title,rejc)

nprogs = size(rejc.data,2);

rejc.year = [rejc.year; 9999];
rejc.data = [rejc.data; median(rejc.data,1)];
fprintf(fid, 'Year,'); fprintf(fid, '%s,', rejc.name{1,1:end-1}); fprintf(fid, '%s\n', rejc.name{1,end});
for  yr = [rejc.year(:)]'

	if yr<9999, fprintf(fid, '%s',num2str(yr)); else fprintf(fid, '%s',title); end
	for pg = 1:nprogs
		rej_rnd = floor(rejc.data(rejc.year==yr,pg));
        % Didn't rank = 0; Ranked 3rd: 1+P+S, Ranked 2nd: 2+P+S, Ranked 3rd: 3+P+S;
		rej_fraq = rejc.data(rejc.year==yr,pg) - rej_rnd;
		if rej_rnd > 0.01, 
            fprintf(fid, ',%d-',4-full(rej_rnd)); 
        else
            fprintf(fid, ',N'); 
        end
		if abs(rej_fraq - 0.25)<0.01, fprintf(fid, 'P');
		elseif abs(rej_fraq - 0.5)<0.01, fprintf(fid, 'S');
		elseif abs(rej_fraq - 0.75)<0.01, fprintf(fid, 'PS');
		else  fprintf(fid, 'R');
		end
	end
	fprintf(fid, '\n');
end
