function pdf_vec = calc_is_weight(V,B,S,Sigma_hat,mu,student_sample,X,n_stu_counter,n_stu_year_mech,n_progs,distances_count)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

    pdf_vec=zeros(1,size(B,2));
% Compute ratio of weights for this draw along the chain
    for ss=1:size(B,2)
        mu_B_ss=reshape(X*B(:,ss),n_stu_counter,n_progs)-distances_count;
        resid_beta_s=V-mu_B_ss(student_sample,:);
        resid_beta_hat=V-mu(student_sample,:);
        resid_diff_sq=(resid_beta_s/S(:,:,ss)).*resid_beta_s-(resid_beta_hat/Sigma_hat).*resid_beta_hat;
        pdf_vec(ss)= (n_stu_year_mech*0.5)*log(det(Sigma_hat)/det(S(:,:,ss)))-0.5*sum(resid_diff_sq(:));        
    end
end

