% Orig
B=[];
S=[];
if ~exist('chains','var'), num_ch = 3; chains = 1:num_ch; else num_ch = numel(chains); end
if ~exist('runs','var'), runs = 201:400; end
if ~exist('draws','var'), draws =  1:5:46; end
if ~exist('seed','var'), seed = 0; end



for ch = 1:num_ch
    for r =runs
        thisCh=load([folder '/chain_' num2str(ch) '_run_' num2str(r) '.mat']);
        B = [B thisCh.all_B_vec(:,draws)];
        S =cat(3,S,thisCh.all_Sigma(:,:,draws));
    end
end
num_sim = size(B,2);
rng(seed) ; new_order = randperm(num_sim);
B = B(:,new_order);
S = S(:,:,new_order);
rnd_details.chains = chains;
rnd_details.runs = runs;
rnd_details.draws = draws;
rnd_details.new_order = new_order;
rnd_details.seed = seed

save([folder '/chain_random.mat'],'B','S','rnd_details');



