function [ B_vec,Sigma,V ,N,Ng ] = readchain(filestem,chain,load_list,thinV,thinAll)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here


B_vec=[];
Sigma =[];
V=[];
N=[];
Ng=[];

if nargin<4 || isempty(thinV), thinV=1; end
if nargin<5 || isempty(thinAll), thinAll=1; end

% Read results from 
for lnum=load_list
    filename=[filestem num2str(chain) '_run_' num2str(lnum) '.mat'];
    if nargout<=2, o=load(filename,'all_B_vec','all_Sigma'); 
    else o=load(filename,'all_*'); end
    if thinAll > 1,
        numDraws = size(o.all_B_vec,2); keepit = 1:thinAll:numDraws;
        o.all_B_vec = o.all_B_vec(:,keepit);
        o.all_Sigma = o.all_Sigma(:,:,keepit);
    end        
    B_vec = [B_vec o.all_B_vec];
    Sigma = cat(3,Sigma,o.all_Sigma);
    if nargout>2,
        if thinV>1.
            numDraws = size(o.all_V,3); keepit = 1:thinV:numDraws;
            o.all_V = o.all_V(:,:,keepit);
        end
        V = cat(3,V,o.all_V); 
    end
    if nargout >3
        if thinAll > 1,
             o.all_N=o.all_N(:,keepit);
             o.all_Ng=o.all_Ng(:,keepit);
        end        
        N = [N o.all_N];
        Ng = [Ng o.all_Ng];
    end
    
end


end



