function write_asgn_table(filename, matrix, headers,total)

n = sum(matrix, 2);
if total
    matrix = 100 * matrix/sum(n);
else
    matrix = 100 * matrix ./ repmat(n, 1, size(matrix, 2));
end

fid = fopen(filename, 'w');
for i = 1:length(headers)
    fprintf(fid, ', %s', headers{i});
end
fprintf(fid, ', N\n');

for i = 1:length(headers)
    fprintf(fid, '%s', headers{i});
    for j = 1:size(matrix, 2)
    	val = matrix(i, j);
	if isnan(val)
	   fprintf(fid, ', 0');
	else
	   fprintf(fid, ', %5.1f%%', matrix(i, j));
	end
    end
    fprintf(fid, ', %d\n', n(i));
end

fclose(fid); 
