function printTable(fid,table,colname,rowname,fixedrows,consolidate,noh)
[rows,cols] = size(table);

c.name = consolidate.name; 
for h =1:numel(consolidate.name), 
	thisname = consolidate.name{h};
	if iscell(thisname)
		c.name{h}=thisname{1};
	else 
		c.name{h} = thisname;
	end
end

[~,c.map] = ismember(c.name,colname);

assert(all(c.map~=0));


if numel(colname) == cols && nargin<7
		fprintf(fid, '%s,', fixedrows.name{:}); fprintf(fid, '%s,',rowname{end}); fprintf(fid, '%s,', c.name{:}); fprintf(fid, '\n');
end
for row =1:rows
	fprintf(fid, '%s,', fixedrows.value{:}); fprintf(fid, '%s,',rowname{row}); fprintf(fid, '%0.2f,', table(row,c.map)); fprintf(fid, '\n');
end

